/***************************************************************************
****  Treiber fr Olivetti JP350WS-Tintenstrahldrucker (HP-kompatibel)  ****
****  Ausdruck um 90 Grad gedreht                                       ****
***************************************************************************/

/* Sollte auch Deskjet und 300dpi Laser bedienen */

/* evt. mu der Rand (LINKS) angepat werden, also:
 * Dazu als Faustregel: 1Pixel = (1/300)" = (25.4/300)mm 
 * (Diese Formel gilt natrlich nur bei 300 DPI.)
 * Fr den oberen Rand gilt es entsprechend
 * (Wenn man diese Datei an einen anderen Drucker anpat, dann diese 
 *  bitte entsprechend umbennen (z.B. HP_LASER.C, dann wre z.B. 
 *  HOEHE=3350, LINKS=??? und an mich senden, BITTE!)
 */

#define OBEN 101L			/* Oberer Rand */
#define LINKS 24L			/* Linker Rand */
#define MAX_DPI 300L	/* Maximale Auflsung 300dpi */
#define BREITE 3360L		/* max. Breite */
#define HOEHE 2336L	/* max. Hhe einer Grafikseite */

#include "hp_90.c"	/* HP-Standarttreiber */


/* email: prissi@marie.physik.tu-berlin.de
 * Post:  Markus Pristovsek
 *        Boumannstrae 66
 *        13467 Berlin
 */